/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Serial2;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.sql.rowset.serial.SerialException;
import javax.swing.JOptionPane;

/**
 *
 * @author tomw
 */
public class MainGUI extends javax.swing.JFrame {
    
    Serial serial;

    /**
     * Creates new form MainGUI
     */
    public MainGUI() throws SerialException {
        initComponents();
        
        this.setTitle("Siliconfish Arduino Serial Comm Tool");
        this.setVisible(true);
        
        // instantiate the serial class with some dummy parameters
        try {
        try {
        serial = new Serial("COM1", Integer.valueOf(serialRates.getSelectedItem().toString()), 'E', 8, 2);
            } catch (UnsatisfiedLinkError e) {
                System.out.println("USB Library rxtxSerial.dll Not Found");
                System.out.println("Exception:" + e.toString()+":"+e.getMessage());
                System.out.println(e.toString());
                JOptionPane.showMessageDialog(null,  
                        "You must copy rxtxSerial.dll from the Arduino software\n " + 
                        "to your local 32 bit java JRE installation\n\n" + 
                        " .../arduino-1.0.1-windows/arduino-1.0.1/rxtxSerial.dll\n" +  
                        "to\n C:/Program Files (x86)/Java/jre7/bin/rxtxSerial.dll\n" +
                        "also right click Properties->Unblock",
                        "Installation Problem",
                        JOptionPane.WARNING_MESSAGE);
            }
            } catch (NoClassDefFoundError e) {
                System.out.println("Missing RXTXcomm.jar in java installation" );
                System.out.println("Exception:" + e.toString()+":"+e.getMessage());
                System.out.println(e.toString());
                JOptionPane.showMessageDialog(null,                     
                        "You must copy RXTXcomm.jar from the Arduino software\n " + 
                        "to your local 32 bit java JRE installation\n\n" + 
                        " .../arduino-1.0.1-windows/arduino-1.0.1/lib/RXTXcomm.jar\n" +  
                        "to\n C:/Program Files (x86)/Java/jre7/lib/ext/RXTXcomm.jar\n" +
                        "also right click Properties->Unblock",
                        "Installation Problem",
                        JOptionPane.WARNING_MESSAGE);
            }
         
        //initial scan for devices and list
        serial.touchPort("", Integer.valueOf(serialRates.getSelectedItem().toString()));
                        jListPorts.setModel(new javax.swing.AbstractListModel() {
                        String[] strings = serial.portNames;
                        public int getSize() { return strings.length; }
                        public Object getElementAt(int i) { return strings[i]; }
        });
                  
                        
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jButtonScan = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        jListPorts = new javax.swing.JList();
        serialRates = new javax.swing.JComboBox();
        jLabelCom = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextAreaRead = new javax.swing.JTextArea();
        jComboBoxFormat = new javax.swing.JComboBox();
        jPanel3 = new javax.swing.JPanel();
        jTextFieldSend = new javax.swing.JTextField();
        jButtonSend = new javax.swing.JButton();
        lineEndings = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Ports"));

        jButtonScan.setText("Scan Ports");
        jButtonScan.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonScanActionPerformed(evt);
            }
        });

        jListPorts.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Scanning", "Ports..." };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListPorts.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListPortsMouseClicked(evt);
            }
        });
        jScrollPane3.setViewportView(jListPorts);

        serialRates.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "300", "1200", "2400", "4800", "9600", "14400", "19200", "28800", "38400", "57600", "115200" }));
        serialRates.setSelectedIndex(4);
        serialRates.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                serialRatesActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane3)
                    .addComponent(jButtonScan, javax.swing.GroupLayout.PREFERRED_SIZE, 97, Short.MAX_VALUE)
                    .addComponent(serialRates, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jButtonScan)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(serialRates, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabelCom.setText("Select Port from List");

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Received"));

        jTextAreaRead.setColumns(20);
        jTextAreaRead.setEditable(false);
        jTextAreaRead.setRows(5);
        jScrollPane2.setViewportView(jTextAreaRead);

        jComboBoxFormat.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "ASCII", "HEX", "Decimal" }));
        jComboBoxFormat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxFormatActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jComboBoxFormat, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jComboBoxFormat, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 23, Short.MAX_VALUE)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 104, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Send"));

        jTextFieldSend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldSendActionPerformed(evt);
            }
        });
        jTextFieldSend.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldSendKeyTyped(evt);
            }
        });

        jButtonSend.setText("Send");
        jButtonSend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSendActionPerformed(evt);
            }
        });

        lineEndings.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "No line ending", "Newline", "Carriage return", "Both NL & CR" }));

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextFieldSend)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(lineEndings, javax.swing.GroupLayout.PREFERRED_SIZE, 112, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 24, Short.MAX_VALUE)
                        .addComponent(jButtonSend)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jTextFieldSend, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonSend)
                    .addComponent(lineEndings, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelCom)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabelCom)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonScanActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonScanActionPerformed
        try {                      
            serial.touchPort("", Integer.valueOf(serialRates.getSelectedItem().toString()));
            jListPorts.setModel(new javax.swing.AbstractListModel() {
                        String[] strings = serial.portNames;
                        public int getSize() { return strings.length; }
                        public Object getElementAt(int i) { return strings[i]; }
            });
            
        } catch (SerialException ex) {
            Logger.getLogger(MainGUI.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonScanActionPerformed

    private void jTextFieldSendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldSendActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldSendActionPerformed

    private void jListPortsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListPortsMouseClicked

        try {
            String reqPort = (String) jListPorts.getSelectedValue();
            if (!reqPort.equals("")) {
                  setupCom((String) jListPorts.getSelectedValue());
            }
        } catch (SerialException ex) {
            Logger.getLogger(MainGUI.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jListPortsMouseClicked

    private void jButtonSendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSendActionPerformed
        serial.write(jTextFieldSend.getText());
        jTextFieldSend.setText("");
    }//GEN-LAST:event_jButtonSendActionPerformed

    private void jComboBoxFormatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxFormatActionPerformed

    }//GEN-LAST:event_jComboBoxFormatActionPerformed

    private String formatRead(int message) {
                String message_out = "";
                switch (jComboBoxFormat.getSelectedIndex()){
                    case 0: {
                        message_out = Character.toString((char) message);
                        break;
                    } //ASCII char
                    case 1: {
                        message_out = "0x"+ Integer.toHexString( message ).concat("\n");
                        break;
                    }  //HEX
                    case 2:   {
                        message_out = String.valueOf(message).concat("\n");
                        break;
                    }  // Integer
                }
        
        return message_out;
        
    }
    
    
    private void jTextFieldSendKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldSendKeyTyped
          if (evt.getKeyChar()== "\n".toCharArray()[0]) {
              serial.write(jTextFieldSend.getText());
              jTextFieldSend.setText("");
           }
    }//GEN-LAST:event_jTextFieldSendKeyTyped

    private void serialRatesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_serialRatesActionPerformed
        try {
            String reqPort = (String) jListPorts.getSelectedValue();
            if (!reqPort.equals("")) {
                  setupCom((String) jListPorts.getSelectedValue());
            }
        } catch (SerialException ex) {
            Logger.getLogger(MainGUI.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_serialRatesActionPerformed

    private void send(String s) {
    if (serial != null) {
      switch (lineEndings.getSelectedIndex()) {
        case 1: s += "\n"; break;
        case 2: s += "\r"; break;
        case 3: s += "\r\n"; break;
      }
      serial.write(s);
    }
  }
  
//  public void openSerialPort() throws SerialException {
//    if (serial != null) return;
//  
//    serial = new Serial(port, serialRate);
//    serial.addListener(this);
//  }
  
//  public void closeSerialPort() {
//    if (serial != null) {
//      int[] location = getPlacement();
//      String locationStr = PApplet.join(PApplet.str(location), ",");
//      Preferences.set("last.serial.location", locationStr);
//      textArea.setText("");
//      serial.dispose();
//      serial = null;
//    }
//  }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        
        /*
        try {
            
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
*/
        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                try {
                    new MainGUI().setVisible(true);
                } catch (SerialException ex) {
                    Logger.getLogger(MainGUI.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });
    }
    
    
    public void setupCom(String portName) throws SerialException{
                //System.out.println(">>"+portName);
                serial.dispose();
                jTextAreaRead.setText(jTextAreaRead.getText()+ "<<" + portName +">>");
                jTextAreaRead.setCaretPosition(jTextAreaRead.getText().length());
                jLabelCom.setText(portName);
                serial = new Serial(portName, Integer.valueOf(serialRates.getSelectedItem().toString()), 'E', 8, 2 );
                
        //Add the listener to pipe remote responses 
        serial.addSerialEventListener(new Listener_SerialEvent() {
            @Override
            public void SerialEventOccurred(int message) {
                String message_out = formatRead(message);           
                jTextAreaRead.setText(jTextAreaRead.getText() + message_out);
                jTextAreaRead.setCaretPosition(jTextAreaRead.getText().length());
            }
        });
    }
    
    
    public static String bytesToHex(byte[] bytes) {
    final char[] hexArray = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
    char[] hexChars = new char[bytes.length * 2];
    int v;
    for ( int j = 0; j < bytes.length; j++ ) {
        v = bytes[j] & 0xFF;
        hexChars[j * 2] = hexArray[v >>> 4];
        hexChars[j * 2 + 1] = hexArray[v & 0x0F];
    }
    return new String(hexChars);
}

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonScan;
    private javax.swing.JButton jButtonSend;
    private javax.swing.JComboBox jComboBoxFormat;
    private javax.swing.JLabel jLabelCom;
    private javax.swing.JList jListPorts;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea jTextAreaRead;
    private javax.swing.JTextField jTextFieldSend;
    private javax.swing.JComboBox lineEndings;
    private javax.swing.JComboBox serialRates;
    // End of variables declaration//GEN-END:variables
}
