//Autor: Marco Biscaro
//marcobiscaro2112@gmail.com
//http://www.guj.com.br/java/149034-duvidas-ao-fazer-uma-consulta
//http://www.guj.com.br/posts/downloadAttach/4732.java
//Código modificado por Esmael Dias Prado.

package tabela.tempos;

import java.util.ArrayList;
import java.util.List;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;


public class TempoTableModel extends AbstractTableModel {

	/**
	 * Essa lista armazenará os objetos do tipo {@link Tempo} atualmente
	 * exibidos na tablela.
	 */
	private List<Tempo> clientes;

	// ==============================================================
	// Construtores.
	// ==============================================================

	/**
	 * Constutor que simplesmente instancia o nosso {@link List} que usaremos
	 * para guardar os valores.
	 */
	public TempoTableModel() {
		// no construtor, instanciamos o List
		clientes = new ArrayList<Tempo>();
	}

	/**
	 * Criamos um construtor de conveniência para já popular a lista.
	 * 
	 * @param lista
	 *            a lista de clientes a ser adicionada.
	 */
	public TempoTableModel(List<Tempo> lista) {
		this();
		clientes.addAll(lista);
	}

	// ==============================================================
	// Métodos implementados.
	// ==============================================================

	@Override
	public Class<?> getColumnClass(int coluna) {
		// todas as colunas representam uma String
		return String.class;
	}

	@Override
	public int getColumnCount() {
		// esse método deve retornar o número de colunas. No caso, 16 (uma para o
		// nome, uma para o sobrenome e uma para o apelido).
		return 16;
	}

	@Override
	public String getColumnName(int coluna) {
		// vamos retornar o nome de cada coluna
		switch (coluna) {
		case 0:
			return "Tempo"; // o nome da primeira coluna
		case 1:
			return "Servo 01"; // o nome da segunda
		case 2:
			return "Servo 02"; // e o da terceira
		case 3:
			return "Servo 03"; // e o da terceira
		case 4:
			return "Servo 04"; // e o da terceira
		case 5:
			return "Servo 05"; // e o da terceira
		case 6:
			return "Servo 06"; // e o da terceira
		case 7:
			return "Servo 07"; // e o da terceira
		case 8:
			return "Servo 08"; // e o da terceira
		case 9:
			return "Servo 09"; // e o da terceira
		case 10:
			return "Servo 10"; // e o da terceira
                case 11:
			return "Servo 11"; // e o da terceira
		case 12:
			return "Servo 12"; // e o da terceira
		case 13:
			return "Servo 13"; // e o da terceira
		case 14:
			return "Servo 14"; // e o da terceira
		case 15:
			return "Servo 15"; // e o da terceira
		default:
			return ""; // isso nunca deve ocorrer, pois temos só 3 colunas
		}
	}

	@Override
	public int getRowCount() {
		// retorna o número de linhas, ou seja, a quantidade de entradas na
		// nossa lista.
		return clientes.size();
	}

	@Override
	public Object getValueAt(int linha, int coluna) {
		// vai retornar o valor de determinada célula. A linha representa a
		// posição do Tempo na nossa lista e a coluna vai ser: 1 - nome, 2 -
		// sobrenome e 3 - apelido
		// primeiro vamos pegar o Tempo da linha
		Tempo c = clientes.get(linha);
		// façamos um switch
		switch (coluna) {
		case 0:
			return c.getNum(); // e o apelido
		case 1:
			return c.getServo01(); // e o apelido
		case 2:
			return c.getServo02(); // e o apelido
		case 3:
			return c.getServo03(); // e o apelido
		case 4:
			return c.getServo04(); // e o apelido
		case 5:
			return c.getServo05(); // e o apelido
		case 6:
			return c.getServo06(); // e o apelido
		case 7:
			return c.getServo07(); // e o apelido
		case 8:
			return c.getServo08(); // e o apelido
		case 9:
			return c.getServo09(); // e o apelido
		case 10:
			return c.getServo10(); // e o apelido
		case 11:
			return c.getServo11(); // e o apelido
		case 12:
			return c.getServo12(); // e o apelido
		case 13:
			return c.getServo13(); // e o apelido
		case 14:
			return c.getServo14(); // e o apelido
		case 15:
			return c.getServo15(); // e o apelido
		default:
			return null; // isso nunca deve ocorrer, pois temos só 3 colunas
		}
	}


        /*
         * 
         */
	public String getLinha(int linha) {
		// vai retornar o valor de determinada célula. A linha representa a
		// posição do Tempo na nossa lista e a coluna vai ser: 1 - nome, 2 -
		// sobrenome e 3 - apelido
		// primeiro vamos pegar o Tempo da linha
		Tempo c = clientes.get(linha);
		// façamos um switch
			return c.getNum() +";"+ 
			c.getServo01() +";"+
			c.getServo02() +";"+
			c.getServo03() +";"+
			c.getServo04() +";"+
			c.getServo05() +";"+
			c.getServo06() +";"+
			c.getServo07() +";"+
			c.getServo08() +";"+
			c.getServo09() +";"+
			c.getServo10() +";"+
			c.getServo11() +";"+
			c.getServo12() +";"+
			c.getServo13() +";"+
			c.getServo14() +";"+
			c.getServo15() +";";
	}

        /**
        *
        * @param linha
        * @param coluna
        * @return
        */
        public String getCelula(int linha, int coluna) {
		// vai retornar o valor de determinada célula. A linha representa a
		// posição do Tempo na nossa lista e a coluna vai ser: 1 - nome, 2 -
		// sobrenome e 3 - apelido
		// primeiro vamos pegar o Tempo da linha
		Tempo c = clientes.get(linha);
		// façamos um switch
		switch (coluna) {
		case 0:
			return c.getNum(); 
		case 1:
			return c.getServo01(); 
		case 2:
			return c.getServo02();
		case 3:
			return c.getServo03(); 
		case 4:
			return c.getServo04(); 
		case 5:
			return c.getServo05(); 
		case 6:
			return c.getServo06(); 
		case 7:
			return c.getServo07(); 
		case 8:
			return c.getServo08(); 
		case 9:
			return c.getServo09(); 
		case 10:
			return c.getServo10(); 
		case 11:
			return c.getServo11(); 
		case 12:
			return c.getServo12();
		case 13:
			return c.getServo13(); 
		case 14:
			return c.getServo14();
		case 15:
			return c.getServo15(); 
		default:
			return null; // isso nunca deve ocorrer, pois temos só 3 colunas
		}
	}

	public void setLinha(int linha, int n1, int s1, int s2, 
                             int s3, int s4, int s5, int s6, 
                             int s7, int s8, int s9, int s10, 
                             int s11, int s12, int s13, int s14, int s15) {
		Tempo c = clientes.get(linha);
		// e vemos o que será atualizado
			c.setNum(Integer.toString(n1)); // e o apelido
			c.setServo01(Integer.toString(s1)); // e o apelido
			c.setServo02(Integer.toString(s2)); // e o apelido
			c.setServo03(Integer.toString(s3)); // e o apelido
			c.setServo04(Integer.toString(s4)); // e o apelido
			c.setServo05(Integer.toString(s5)); // e o apelido
			c.setServo06(Integer.toString(s6)); // e o apelido
			c.setServo07(Integer.toString(s7)); // e o apelido
			c.setServo08(Integer.toString(s8)); // e o apelido
		        c.setServo09(Integer.toString(s9)); // e o apelido
			c.setServo10(Integer.toString(s10)); // e o apelido
			c.setServo11(Integer.toString(s11)); // e o apelido
			c.setServo12(Integer.toString(s12)); // e o apelido
			c.setServo13(Integer.toString(s13)); // e o apelido
			c.setServo14(Integer.toString(s14)); // e o apelido
			c.setServo15(Integer.toString(s15)); // e o apelido
		// é importante notificar os listeners a cada alteração
		fireTableDataChanged();
	}        

    public void setLinha(int linha, String n1, String s1, String s2,
            String s3, String s4, String s5, String s6,
            String s7, String s8, String s9, String s10,
            String s11, String s12, String s13, String s14, String s15) {
        Tempo c = clientes.get(linha);
        // e vemos o que será atualizado
        c.setNum(n1); // e o apelido
        c.setServo01(s1); // e o apelido
        c.setServo02(s2); // e o apelido
        c.setServo03(s3); // e o apelido
        c.setServo04(s4); // e o apelido
        c.setServo05(s5); // e o apelido
        c.setServo06(s6); // e o apelido
        c.setServo07(s7); // e o apelido
        c.setServo08(s8); // e o apelido
        c.setServo09(s9); // e o apelido
        c.setServo10(s10); // e o apelido
        c.setServo11(s11); // e o apelido
        c.setServo12(s12); // e o apelido
        c.setServo13(s13); // e o apelido
        c.setServo14(s14); // e o apelido
        c.setServo15(s15); // e o apelido
        // é importante notificar os listeners a cada alteração
        fireTableDataChanged();
    }

        
	@Override
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		// nesse caso, todas as células são editáveis
		return true;
	}

	@Override
	public void setValueAt(Object valor, int linha, int coluna) {
		// aqui devemos atualizar o valor de nossos Clientes
		// vemos em qual linha ele está
		Tempo c = clientes.get(linha);
		// e vemos o que será atualizado
		switch (coluna) {
		case 0:
			c.setNum(valor.toString()); // e o apelido
                        break;  
                case 1:
			c.setServo01(valor.toString()); // e o apelido
                        break;  
		case 2:
			c.setServo02(valor.toString()); // e o apelido
                        break;  
		case 3:
			c.setServo03(valor.toString()); // e o apelido
                        break;  
		case 4:
			c.setServo04(valor.toString()); // e o apelido
                        break;  
		case 5:
			c.setServo05(valor.toString()); // e o apelido
                        break;  
		case 6:
			c.setServo06(valor.toString()); // e o apelido
                        break;  
		case 7:
			c.setServo07(valor.toString()); // e o apelido
                        break;  
		case 8:
			c.setServo08(valor.toString()); // e o apelido
                        break;  
		case 9:
		        c.setServo09(valor.toString()); // e o apelido
                        break;  
		case 10:
			c.setServo10(valor.toString()); // e o apelido
                        break;  
		case 11:
			c.setServo11(valor.toString()); // e o apelido
                        break;  
		case 12:
			c.setServo12(valor.toString()); // e o apelido
                        break;  
		case 13:
			c.setServo13(valor.toString()); // e o apelido
                        break;  
		case 14:
			c.setServo14(valor.toString()); // e o apelido
                        break;  
		case 15:
			c.setServo15(valor.toString()); // e o apelido
                        break;  
		}
		// é importante notificar os listeners a cada alteração
		fireTableDataChanged();
	}

	// ==============================================================
	// Até aqui seria o mínimo necessário para um TableModel funcional, mas
	// ainda não há métodos para adicionar, remover ou resgatar objetos. Vamos
	// criá-los.
	// ==============================================================

	/**
	 * Adiciona um novo {@link Tempo} e notifica os listeners que um novo
	 * registro foi adicionado.
	 */
	public void adiciona(Tempo c) {
		clientes.add(c);
		// informamos os listeners que a linha (size - 1) foi adicionada
		fireTableRowsInserted(clientes.size() - 1, clientes.size() - 1);
	}

	/**
	 * Similar ao {@link #adiciona(Tempo)}, porém para remover. Recebe o
	 * índice do Tempo a ser removido. Se não souber o índice, use o método
	 * {@link #getIndice(Tempo)} antes.
	 */
	public void remove(int indice) {
		clientes.remove(indice);
		fireTableRowsDeleted(indice, indice);
                TempoLinhas.i_MenosMenos();
	}

	/**
	 * Retorna o índice de determinado Tempo.
	 */
	public int getIndice(Tempo c) {
		return clientes.indexOf(c);
	}

	/**
	 * Adiciona todos os clientes na lista à este modelo.
	 */
	public void adicionaLista(List<Tempo> lista) {
		int i = clientes.size();
		clientes.addAll(lista);
		fireTableRowsInserted(i, i + lista.size());
	}

	/**
	 * Esvazia a lista.
	 */
	public void limpaLista() {
		int i = clientes.size();
		clientes.clear();
		fireTableRowsDeleted(0, i - 1);
	}

}
