//---------------------------------------------------------------------------
#define USB_HID_DEVICE FALSE 
#define USB_EP1_TX_ENABLE USB_ENABLE_BULK 
#define USB_EP1_RX_ENABLE USB_ENABLE_BULK 
#define USB_EP1_TX_SIZE 64 
#define USB_EP1_RX_SIZE 64 

#include <pic18_usb.h> 
#include "header.h" 
#include <usb.c> 

#define ComandoPC DatosBuffer[0]
#define ParametroPC DatosBuffer[1]
#define TIPO_COMANDO '@'

const int8 TamBuffer = 64; 
int8 DatosBuffer[TamBuffer];
boolean led1=0;
//----------------------------------------------------------------------------

//****************************************************************************
//@Comando ;10000000000000000;21300;21300;21300;21300;21300;21300 (8Pacot(Comandos 9 digitos +17 dig temp+6 motores ))                                           
//@Comando ;21300;21300;21300;21300;21300;21300;21300;21300;21300 (10Pacot(Comandos 9 digitos + 9 Motores))
int16 dec_pac_comando(void){
			
			int i;
			char comando[10]="";

			//9- Bytes de Comandos--------------------------------------------------------------
			for(i=0;i<=8;i++){
				comando[i]=DatosBuffer[i];
			}
			comando[9]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[0]=DatosBuffer[9];
			//----------------------------------------------------------------------------------

	if('@' == comando[0]){return 1;}
	if('#' == comando[0]){return 2;}
	if('$' == comando[0]){return 3;}
	if('%' == comando[0]){return 4;}
	if('&' == comando[0]){return 5;}
	if('w' == comando[0]){return 6;}
	if('r' == comando[0]){return 7;}
	if('s' == comando[0]){return 8;}
	if('m' == comando[0]){return 9;}	//Gravacao da memoria
	if('z' == comando[0]){return 10;}	//Apaga a memoria
	if('d' == comando[0]){return 11;}   //Teste de leitura da memoria
	if('t' == comando[0]){return 12;}   //Tensao das fontes

	return 0;
}
//****************************************************************************


//****************************************************************************
//Formato do pacote PC1
//@Comando ;00000000000000000;20000;00000;20000;00000;20000;00000  //pc1 - esquerda
void dec_pac_mem_servo_1_6(void){
	
			int i;
			int16 temp;
			char st1[6]="", st2[6]="", st3[6]="", st4[6]="", st5[6]="", st6[6]="";
			//char endereco_mem[18]="";

			//17- Byte para endereamento de memria--------------------------------------------
			//valor 00.000.000.000.000.000 at 99.999.999.999.999.999
			//for(i=10;i<=26;i++){
			//	endereco_mem[i-10]=DatosBuffer[i];
			//}
			//endereco_mem[17]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[1]=DatosBuffer[27];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 1 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=28;i<=32;i++){
				st1[i-28]=DatosBuffer[i];
			}
			st1[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[2]=DatosBuffer[33];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 2 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=34;i<=38;i++){
				st2[i-34]=DatosBuffer[i];
			}
			st2[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[3]=DatosBuffer[39];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 3 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=40;i<=44;i++){
				st3[i-40]=DatosBuffer[i];
			}
			st3[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[4]=DatosBuffer[45];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 4 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=46;i<=50;i++){
				st4[i-46]=DatosBuffer[i];
			}
			st4[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[5]=DatosBuffer[51];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 5 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=52;i<=56;i++){
				st5[i-52]=DatosBuffer[i];
			}
			st5[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[6]=DatosBuffer[57];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 6 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=58;i<=62;i++){
				st6[i-58]=DatosBuffer[i];
			}
			st6[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[7]=DatosBuffer[63];
			//----------------------------------------------------------------------------------

			//Motor 1 = limite min 130 + 7900 = 8030,   Limite Max = 21100 + 7900 = 29000
			temp = atol(st1);
			if(temp<130){temp=130;}
			if(temp>20920){temp=20920;}
			servo1 = temp+7900;

			//Motor 2 = limite min 130 + 7900 = 8030,   Limite Max = 20360 + 7900 = 28260
			temp = atol(st2);
			if(temp<130){temp=130;}
			if(temp>20360){temp=20360;}	
			servo2 = temp+7900;

			//Motor 3 = limite min 130 + 7900 = 8030,   Limite Max = 20360 + 7900 = 28260
			temp = atol(st3);
			if(temp<130){temp=130;}
			if(temp>20360){temp=20360;}	
			servo3 = temp+7900;

			//Motor 4 = limite min 600 + 7900 = 8500,   Limite Max = 20900 + 7900 = 28800
			temp = atol(st4);
			if(temp<600){temp=600;}
			if(temp>20900){temp=20900;}
			servo4 = temp+7900;

			//Motor 5 = limite min 600 + 7900 = 8500,   Limite Max = 20900 + 7900 = 28800
			temp = atol(st5);
			if(temp<600){temp=600;}
			if(temp>20900){temp=20900;}
			servo5 = temp+7900;

			//Motor 6 = limite min 1127 + 7900 = 8500,   Limite Max = 18450 + 7900 = 26350
			temp = atol(st6);
			if(temp<1127){temp=1127;}
			if(temp>18450){temp=18450;}
			servo6 = temp+7900;


}
//****************************************************************************
//Formato do pacote PC2
//#Comando ;20000;00000;20000;00000;20000;00000;20000;20000;20000  //pc2 - esquerda
void dec_pac_mem_servo_7_15(void){

			int i;
			int16 temp;
			char st7[6]="", st8[6]="", st9[6]="", st10[6]="";
			char st11[6]="",st12[6]="", st13[6]="", st14[6]="", st15[6]="";

			//5- Bytes Valor do servo 7 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=10;i<=14;i++){
				st7[i-10]=DatosBuffer[i];
			}
			st7[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[1]=DatosBuffer[15];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 8 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=16;i<=20;i++){
				st8[i-16]=DatosBuffer[i];
			}
			st8[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[2]=DatosBuffer[21];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 9 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=22;i<=26;i++){
				st9[i-22]=DatosBuffer[i];
			}
			st9[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[3]=DatosBuffer[27];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 10 -------------------------------------------------------
			//valor 00000 at 21300
			for(i=28;i<=32;i++){
				st10[i-28]=DatosBuffer[i];
			}
			st10[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[4]=DatosBuffer[33];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 11 -------------------------------------------------------
			//valor 00000 at 21300
			for(i=34;i<=38;i++){
				st11[i-34]=DatosBuffer[i];
			}
			st11[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[5]=DatosBuffer[39];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 12 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=40;i<=44;i++){
				st12[i-40]=DatosBuffer[i];
			}
			st12[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[6]=DatosBuffer[45];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 13 -------------------------------------------------------
			//valor 00000 at 21300
			for(i=46;i<=50;i++){
				st13[i-46]=DatosBuffer[i];
			}
			st13[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[7]=DatosBuffer[51];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 14 -------------------------------------------------------
			//valor 00000 at 21300
			for(i=52;i<=56;i++){
				st14[i-52]=DatosBuffer[i];
			}
			st14[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[8]=DatosBuffer[57];
			//----------------------------------------------------------------------------------

			//5- Bytes Valor do servo 15 --------------------------------------------------------
			//valor 00000 at 21300
			for(i=58;i<=62;i++){
				st15[i-58]=DatosBuffer[i];
			}
			st15[5]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[9]=DatosBuffer[63];
			//----------------------------------------------------------------------------------

			//Motor 7 = limite min 2550 + 7900 = 8500,   Limite Max = 19590 + 7900 = 27490
			temp = atol(st7);
			if(temp<2550){temp=2550;}
			if(temp>19590){temp=19590;}
			servo7 = temp+7900;


			temp = atol(st8);
			servo8 = temp+7900;
			temp = atol(st9);
			servo9 = temp+7900;
			temp = atol(st10);
			servo10 = temp+7900;
			temp = atol(st11);
			servo11 = temp+7900;
			temp = atol(st12);
			servo12 = temp+7900;
			temp = atol(st13);
			servo13 = temp+7900;
			temp = atol(st14);
			servo14 = temp+7900;
			temp = atol(st15);
			servo15 = temp+7900;
}
//****************************************************************************


//****************************************************************************
//Formato do pacote de dados para emergncia
//"$Comando ;00000000000000000;0" Desliga pulsos (Emergncia)
//"$Comando ;00000000000000000;1" liga pulsos
void dec_pac_liga_desliga(void){

			//int i;
			//int16 temp;
			char st1[2]=" ";
			
			//17- Byte para endereamento de memria--------------------------------------------
			//valor 00.000.000.000.000.000 at 99.999.999.999.999.999
			//No utilizado
				//for(i=10;i<=26;i++){
				//	endereco_mem[i-10]=DatosBuffer[i];
				//}
				//endereco_mem[17]='\0';
			//----------------------------------------------------------------------------------

			//1- Byte Ponto e virgula-----------------------------------------------------------
            //virgula[1]=DatosBuffer[27];
			//----------------------------------------------------------------------------------

			//1- Byte --------------------------------------------------------------------------
            //se o char for igual a '0' desliga os pulsos dos motores
			//----------------------------------------------------------------------------------
			st1[1]=DatosBuffer[28];

			if(st1[1]=='0'){
				LIG_DESL_SERVOS=0;
			}
			//----------------------------------------------------------------------------------

			//1- Byte --------------------------------------------------------------------------
            //se o char for igual a 'l' liga os pulsos dos motores
			//----------------------------------------------------------------------------------
			if(st1[1]=='1'){
				LIG_DESL_SERVOS=1;
			}
			//----------------------------------------------------------------------------------
}
//****************************************************************************


//****************************************************************************
//%Comando ;00000000000000000;20000;00000;20000;00000;20000;00000
void manda_dados_motor_pc1(void){

	sprintf(DatosBuffer,"%%Comando ;00000000000000000;%05Ld;%05Ld;%05Ld;%05Ld;%05Ld;%05Ld ",
						servo1-7900, servo2-7900, servo3-7900, servo4-7900, servo5-7900, servo6-7900); 
}
//****************************************************************************


//****************************************************************************
//&Comando ;20000;00000;20000;00000;20000;00000;20000;20000;20000
void manda_dados_motor_pc2(void){

	sprintf(DatosBuffer,"&Comando ;%05Ld;%05Ld;%05Ld;%05Ld;%05Ld;%05Ld;%05Ld;%05Ld;%05Ld ", 
                    servo7-7900, servo8-7900, servo9-7900, servo10-7900, servo11-7900, 
                    servo12-7900, servo13-7900, servo14-7900, servo15-7900);
}
//**************************************************************************** 


//**************************************************************************** 
//Formato do pacote PC1
//rComando ;00000000000000000;20000;00000;20000;00000;20000;00000  //pc1
// Tamanho  - Tamanho    - tamanho Hex - ltimo End HEX - Ultimo End Dec
//  16 kbit -   2 KBytes - 800         - 007FF
//  32 kbit	-   4 KBytes - 1000	       - 00FFF
//  64 kbit	-   8 KBytes - 2000	       - 01FFF
// 128 kbit	-  16 KBytes - 4000	       - 03FFF
// 256 kbit	-  32 KBytes - 8000	       - 07FFF
// 512 kbit	-  64 KBytes - 10000	   - 0FFFF           -  65.535
//   1 Mbit	- 128 KBytes - 20000	   - 1FFFF           - 131.071
//   2 Mbit	- 256 kbytes - 40000	   - 3FFFF
//   4 Mbit	- 512 kbyte	 - 80000	   - 7FFFF

void escrita_memoria(void){
	
	int   i;
	char  st1[6]="";//,st2[6]="";
	int32 endereco;
	int16 valor_men; 
	int8  valor_men_byte,valor_men_byte_l,valor_men_byte_h;  
	int   seleciona_men;
	char endereco_mem[18]=""; 

	//17- Byte para endereamento de memria--------------------------------------------
	//valor 00.000.000.000.000.000 at 99.999.999.999.999.999
	for(i=10;i<=26;i++){
		endereco_mem[i-10]=DatosBuffer[i];
	}
	endereco_mem[17]='\0';
	//----------------------------------------------------------------------------------

	//1- Byte Ponto e virgula-----------------------------------------------------------
    //virgula[1]=DatosBuffer[27];
	//----------------------------------------------------------------------------------

	//5- Bytes Valor do servo 1 --------------------------------------------------------
	//valor 00000 at 21300
	for(i=28;i<=32;i++){
		st1[i-28]=DatosBuffer[i];
	}
	st1[5]='\0';
	//----------------------------------------------------------------------------------

	//5- Bytes Valor do servo 2 --------------------------------------------------------
	//valor 00000 at 21300
	//for(i=34;i<=38;i++){
	//	st2[i-34]=DatosBuffer[i];
	//}
	//st2[5]='\0';
	//----------------------------------------------------------------------------------
	
	endereco=atof(endereco_mem);
	
	//sprintf(endereco,"%i",endereco_mem);
	
	valor_men=atol(st1);

	//Estouro de memoria >196.605
	if( endereco <= 196605 ){
		seleciona_men = 1;
		if(endereco>65535){
			seleciona_men = 2;
			if(endereco>131070){
				seleciona_men = 3;
				if(endereco>196605){
					seleciona_men = 4;
					if(endereco>262140){
						seleciona_men = 5;
						if(endereco>327675){
							seleciona_men = 6;
							if(endereco>393210){
								seleciona_men = 7;
								if(endereco>458745){
									seleciona_men = 8;
									if(endereco>524280){
										seleciona_men = 1;
									}
								}	
							}
						}
					}
				}
			}
		}
/*
	//Estouro de memoria >196.607
	if( endereco <= 196607 ){			//Se o endereo for menor ou igual a 196607 entra, endereo vlido.
		seleciona_men = 1;				//Selecione o banco 1 de memria
		if(endereco>65535){				//Se for maior que entre (0 e 65535), ento pode ser banco 2 apartir de 65536;
			seleciona_men = 2;			//Selecione o banco 2 de memria
			if(endereco>131071){		//Se for maior que entre (65536 e 131071 ), ento pode ser banco 3 apartir de 131072;
				seleciona_men = 3;		//Selecione o banco 3 de memria
				if(endereco>196607){	//Se for maior que entre (131071 e 196607), ento pode ser banco 4 apartir de 196608;
					seleciona_men = 1;  //Selecione o banco 1 de memria pois o banco 4 no exite. h um erro.

				}
			}
		}
*/	
	
	//Bin = 0101.1001 1101.1000, Dec = 23000---------------------------------
	//Escrita de 16Bits ne memoria Eeprom
	//Escreve Byte baixo----------------------------------
	//init_ext_eeprom___;
	//Envia os 8 bits mais baixo da varivel de 16 bits
	valor_men_byte = make8(valor_men,0);
    write_ext_eeprom(endereco,valor_men_byte, seleciona_men);
	//Escreve Byte alto----------------------------------
	//init_ext_eeprom__;
	//Envia os 8 bits mais baixo da varivel de 16 bits
	valor_men_byte = make8(valor_men,1);
    write_ext_eeprom(endereco+1,valor_men_byte, seleciona_men);
	//------------------------------------------------------------------------

	//Bin = 0101.1001 1101.1000, Dec = 23000---------------------------------
	//Leitura de 16Bits ne memoria Eeprom
	//Recebe os 8 bits mais baixo e da memoria de 16 bits
	valor_men_byte_l = read_ext_eeprom(endereco,seleciona_men);
	//Recebe os 8 bits mais baixo e da memoria de 16 bits
	valor_men_byte_h = read_ext_eeprom(endereco+1,seleciona_men);
	//Agrupa os bites alto e baixo na variavel 16 bitis
	valor_men = make16(valor_men_byte_h,valor_men_byte_l);
	//------------------------------------------------------------------------

	sprintf(DatosBuffer,"wComando ;%017Ld;%05u;%05u;00000;00000;00000;%05u ",
                        endereco, valor_men_byte_l, valor_men_byte_h, seleciona_men);
	}else{
		sprintf(DatosBuffer,"wEstouro ;00000000000000000;00000;00000;00000;00000;00000;00000 ");
	}
}
//**************************************************************************** 


//**************************************************************************** 
//Formato do pacote PC1
//rComando ;00000000000000000;20000;00000;20000;00000;20000;00000  //pc1
// Tamanho  - Tamanho    - tamanho Hex - ltimo End HEX - Ultimo End Dec
//  16 kbit -   2 KBytes - 800         - 007FF
//  32 kbit	-   4 KBytes - 1000	       - 00FFF
//  64 kbit	-   8 KBytes - 2000	       - 01FFF
// 128 kbit	-  16 KBytes - 4000	       - 03FFF
// 256 kbit	-  32 KBytes - 8000	       - 07FFF
// 512 kbit	-  64 KBytes - 10000	   - 0FFFF           -  65.535
//   1 Mbit	- 128 KBytes - 20000	   - 1FFFF           - 131.071
//   2 Mbit	- 256 kbytes - 40000	   - 3FFFF
//   4 Mbit	- 512 kbyte	 - 80000	   - 7FFFF
//--------------------------------------------------------
//Definindo os endereos Vlidos para os bancos de memria
//memria 1
//0-65535 = 65536
//memria 2
//0-65535 = 65536
//memria 3
//0-65535 = 65536
//          ----- 
//Total   = 196608
//Endereo validos (0 - 196607)
//..................................................
//memria 1	End. Validos (0 + 65535) = 65535	  
//0			0   				
//65535		65535
//
//memria 2	End. Validos (65536 + 65535) = 131071	  
//0       	65536 	
//65535   	131071
//
//memria 3	End. Validos (131072  + 65535) = 196607	  
//0       	131072  
//65535   	196607
//------------------------------------------------------
void leitura_memoria(void){ //ok
	
	int i;
	int32 endereco;
	int   seleciona_men;
	char endereco_mem[18]=""; 

	//17- Byte para endereamento de memria--------------------------------------------
	//valor 00.000.000.000.000.000 at 99.999.999.999.999.999
	for(i=10;i<=26;i++){
		endereco_mem[i-10]=DatosBuffer[i];
	}
	endereco_mem[17]='\0';
	//----------------------------------------------------------------------------------

	endereco=atof(endereco_mem);

	//memria 1	End. Validos (0 + 65535) = 65535	  
	//0			0   				
	//65535		65535
	//memria 2	End. Validos (65536 + 65535) = 131071	  
	//0       	65536 	
	//65535   	131071
	//memria 3	End. Validos (131072  + 65535) = 196607	  
	//0       	131072  
	//65535   	196607

	//Estouro de memoria >196.607
	if( endereco <= 196607 ){			//Se o endereo for menor ou igual a 196607 entra, endereo vlido.
		seleciona_men = 1;				//Selecione o banco 1 de memria
		if(endereco>65535){				//Se for maior que entre (0 e 65535), ento pode ser banco 2 apartir de 65536;
			seleciona_men = 2;			//Selecione o banco 2 de memria
			if(endereco>131071){		//Se for maior que entre (65536 e 131071 ), ento pode ser banco 3 apartir de 131072;
				seleciona_men = 3;		//Selecione o banco 3 de memria
				if(endereco>196607){	//Se for maior que entre (131071 e 196607), ento pode ser banco 4 apartir de 196608;
					seleciona_men = 1;  //Selecione o banco 1 de memria pois o banco 4 no exite. h um erro.

				}
			}
		}
		sprintf(DatosBuffer,"rComando ;%017Ld;%05u;%05u;00000;00000;00000;%05u ",
                        endereco,read_ext_eeprom(endereco,seleciona_men),read_ext_eeprom(endereco+1,seleciona_men),seleciona_men);
	}else{								//Se  maior que 196.607, manda o endereo de volta sem informao 
		sprintf(DatosBuffer,"rEstouro ;%017Ld;00000;00000;00000;00000;00000;00000 ",endereco);
	}
							
}
//**************************************************************************** 


//**************************************************************************** 
//Formato do pacote PC1
//sComando ;00000000000000000;20000;00000;20000;00000;20000;00000  //pc1
// Tamanho  - Tamanho    - tamanho Hex - ltimo End HEX - Ultimo End Dec
//  16 kbit -   2 KBytes - 800         - 007FF
//  32 kbit	-   4 KBytes - 1000	       - 00FFF
//  64 kbit	-   8 KBytes - 2000	       - 01FFF
// 128 kbit	-  16 KBytes - 4000	       - 03FFF
// 256 kbit	-  32 KBytes - 8000	       - 07FFF
// 512 kbit	-  64 KBytes - 10000	   - 0FFFF           -  65.535
//   1 Mbit	- 128 KBytes - 20000	   - 1FFFF           - 131.071
//   2 Mbit	- 256 kbytes - 40000	   - 3FFFF
//   4 Mbit	- 512 kbyte	 - 80000	   - 7FFFF

void escrita_memoria_sequencial(void){
	
	int   i;
	char  st1[6]="";//,st2[6]="";
	int32 endereco;
	int16 valor_men; 
	//int8  valor_men_byte,valor_men_byte_l,valor_men_byte_h;  
	int   seleciona_men; 
	char endereco_mem[18]="";

	int8 a[130];

	//17- Byte para endereamento de memria--------------------------------------------
	//valor 00.000.000.000.000.000 at 99.999.999.999.999.999
	for(i=10;i<=26;i++){
		endereco_mem[i-10]=DatosBuffer[i];
	}
	endereco_mem[17]='\0';
	//----------------------------------------------------------------------------------

	//1- Byte Ponto e virgula-----------------------------------------------------------
    //virgula[1]=DatosBuffer[27];
	//----------------------------------------------------------------------------------

	//5- Bytes Valor do servo 1 --------------------------------------------------------
	//valor 00000 at 21300
	for(i=28;i<=32;i++){
		st1[i-28]=DatosBuffer[i];
	}
	st1[5]='\0';
	//----------------------------------------------------------------------------------

	//5- Bytes Valor do servo 2 --------------------------------------------------------
	//valor 00000 at 21300
	//for(i=34;i<=38;i++){
	//	st2[i-34]=DatosBuffer[i];
	//}
	//st2[5]='\0';
	//----------------------------------------------------------------------------------
	
	endereco=atof(endereco_mem);
	
	//sprintf(endereco,"%i",endereco_mem);
	
	valor_men=atol(st1);

	//Estouro de memoria >196.605
	if( endereco <= 196605 ){
		seleciona_men = 1;
		if(endereco>65535){
			seleciona_men = 2;
			if(endereco>131070){
				seleciona_men = 3;
				if(endereco>196605){
					seleciona_men = 4;
					if(endereco>262140){
						seleciona_men = 5;
						if(endereco>327675){
							seleciona_men = 6;
							if(endereco>393210){
								seleciona_men = 7;
								if(endereco>458745){
									seleciona_men = 8;
									if(endereco>524280){
										seleciona_men = 1;
									}
								}	
							}
						}
					}
				}
			}
		}
	}
/*
	//Estouro de memoria >196.607
	if( endereco <= 196607 ){		//Se o endereo for menor ou igual a 196607 entra, endereo vlido.
		seleciona_men = 1;					//Selecione o banco 1 de memria
		if(endereco>65535){			//Se for maior que entre (0 e 65535), ento banco 2 apartir de 65536;
			seleciona_men = 2;				//Selecione o banco 2 de memria
			if(endereco>131071){		//Se for maior que entre (65536 e 131071 ), ento banco 3 apartir de 131072;
				seleciona_men = 3;			//Selecione o banco 3 de memria
				if(endereco>196607){	//Se for maior que entre (131071 e 196607), ento banco 4 apartir de 196608;
					seleciona_men = 1;  	//Selecione o banco 1 de memria pois o banco 4 no exite. h um erro.

				}
			}
		}

*/	
/*	
	//Bin = 0101.1001 1101.1000, Dec = 23000---------------------------------
	//Escrita de 16Bits ne memoria Eeprom
	//Escreve Byte baixo----------------------------------
	//init_ext_eeprom____;
	//Envia os 8 bits mais baixo da varivel de 16 bits
	valor_men_byte = make8(valor_men,0);
    write_ext_eeprom(endereco,valor_men_byte, seleciona_men);
	//Escreve Byte alto----------------------------------
	//init_ext_eeprom____;
	//Envia os 8 bits mais baixo da varivel de 16 bits
	valor_men_byte = make8(valor_men,1);
    write_ext_eeprom(endereco+1,valor_men_byte, seleciona_men);
	//------------------------------------------------------------------------

	//Bin = 0101.1001 1101.1000, Dec = 23000---------------------------------
	//Leitura de 16Bits ne memoria Eeprom
	//Recebe os 8 bits mais baixo e da memoria de 16 bits
	valor_men_byte_l = read_ext_eeprom(endereco,seleciona_men);
	//Recebe os 8 bits mais baixo e da memoria de 16 bits
	valor_men_byte_h = read_ext_eeprom(endereco+1,seleciona_men);
	//Agrupa os bites alto e baixo na variavel 16 bitis
	valor_men = make16(valor_men_byte_h,valor_men_byte_l);
	//------------------------------------------------------------------------

	sprintf(DatosBuffer,"wComando ;%017Ld;%05u;%05u;00000;00000;00000;%05u ",
                        endereco, valor_men_byte_l, valor_men_byte_h, seleciona_men);
	}else{
		sprintf(DatosBuffer,"wEstouro ;00000000000000000;00000;00000;00000;00000;00000;00000 ");
	}

*/


	
	for(i=0;i < 129; i++){
		a[i]=i;
	}

	//Escrita sequencial, lembrado que as pginas tem que ser de 128 em 128 Bytes. at 65535
	//   0 ----- 127
	// 128 ----- 255
	// 256 ----- 383
	// 384 ----- 511
	// 639 ----- 766 
	//  ... at  65535
    //
    //
	//write_ext_eeprom_sequencial(long int address, BYTE data[], int tamanho_data, int dispositivo)
	write_ext_eeprom_sequencial(endereco,a,128,seleciona_men);

	sprintf(DatosBuffer,"sComando ;%017Ld;00000;00000;00000;00000;00000;%05u ",
                        endereco,seleciona_men);
}
//**************************************************************************** 


//**************************************************************************** 
//Formato do pacote
//Informacoes de memria, a utilizada  3 x 512 kbit = 3 x 65.535 Bytes, 
//total 196.605 Bytes endereaveis.
// Tamanho  - Tamanho    - tamanho Hex - ltimo End HEX - Ultimo End Dec
//  16 kbit -   2 KBytes - 800         - 007FF
//  32 kbit	-   4 KBytes - 1000	       - 00FFF
//  64 kbit	-   8 KBytes - 2000	       - 01FFF
// 128 kbit	-  16 KBytes - 4000	       - 03FFF
// 256 kbit	-  32 KBytes - 8000	       - 07FFF
// 512 kbit	-  64 KBytes - 10000	   - 0FFFF           -  65.535
//   1 Mbit	- 128 KBytes - 20000	   - 1FFFF           - 131.071
//   2 Mbit	- 256 kbytes - 40000	   - 3FFFF
//   4 Mbit	- 512 kbyte	 - 80000	   - 7FFFF
//----------------------------------------------------------------------
//Recebendo o pacote Hex (char + char) de dados para memoria via USB
//A memoria tem Pagina de 128 Bytes, desta for a soma dos recebimentos do 
//pacote tem de ser uma sob diviso de 128 ou Somas que resultam 128 Bytes Ex.:
//128/2 = 64, 128/4 = 32, 128/8 = 16.  ou 
//43+43+42 = 128, 56 + 56 + 16 = 128
//Para equilibrar o pacote foi escolilhado soma de "43" sobrando 64-43 = 21 para 
//demais aplicao. 
//O Pacote ficou assim:
//mComando ;ppppp;ddddddddddddddddddddddddddddddddddddddddddd;cccc
//Comando com 10 Bytes: "mComando ;"
//Subdivisao do pacote 128 Bytes registrando tamnho do pacote 43, 42 
//ou menor quando for o final do pacote: "ppppp;" Ex.: "00043;" 
//Dados da memoria 43 Byte: "ddddddddddddddddddddddddddddddddddddddddddd;"
//Dados da memoria 42 Byte: "dddddddddddddddddddddddddddddddddddddddddd#;"
//Dados da memoria 40 Byte: "dddddddddddddddddddddddddddddddddddddddd###;"
//Para Aplicacao futura de CRC: "cccc"
//----------------------------------------------------------------------             
void escrita_memoria_bloco_128(void){  //ok
	
	int   i;
	char  st1[8]="";
	int   tamanho_pacote;
	int   seleciona_men;
	int32 endereco; 
	int8  a[44];
	char  endereco_mem[8]="";



	//Tamanho do pacote (0-63) = 64 Bytes
	//mComand |pp |eeeeee|ddddddddddddddddddddddddddddddddddddddddddd;cccc
	//0------7|8-9|10--15|16---------------------------------------58|60-63|
	//----------------------------------------------------------------------------------
	for(i=8;i<=9;i++){
		st1[i-8]=DatosBuffer[i];
	}
	st1[3]='\0';
	tamanho_pacote = atol(st1);
	//----------------------------------------------------------------------------------

	//----------------------------------------------------------------------------------
	for(i=10;i<=15;i++){
		endereco_mem[i-10]=DatosBuffer[i];
	}
	endereco_mem[7]='\0';
	endereco = atof(endereco_mem);
	//----------------------------------------------------------------------------------

	//----------------------------------------------------------------------------------

	//Se o tamanho do pacote  43 ento o valor  de (0-42) => (58 - 16 = 42)
	for(i=16;i<tamanho_pacote+16;i++){
		a[i-16]=DatosBuffer[i];
	}
	a[tamanho_pacote]='\0';
	//----------------------------------------------------------------------------------


	//A variavel endereco  global e  iniciada com zero;
	//memria 1	End. Validos (0 + 65535) = 65535	  
	//0			0   				
	//65535		65535
	//memria 2	End. Validos (65536 + 65535) = 131071	  
	//0       	65536 	
	//65535   	131071
	//memria 3	End. Validos (131072  + 65535) = 196607	  
	//0       	131072  
	//65535   	196607

	//Estouro de memoria >196.607
	if( endereco <= 196607 ){		//Se o endereo for menor ou igual a 196607 entra, endereo vlido.
		seleciona_men = 1;					//Selecione o banco 1 de memria
		if(endereco>65535){			//Se for maior que entre (0 e 65535), ento banco 2 apartir de 65536;
			seleciona_men = 2;				//Selecione o banco 2 de memria
			if(endereco>131071){		//Se for maior que entre (65536 e 131071 ), ento banco 3 apartir de 131072;
				seleciona_men = 3;			//Selecione o banco 3 de memria
				if(endereco>196607){	//Se for maior que entre (131071 e 196607), ento banco 4 apartir de 196608;
					seleciona_men = 1;  	//Selecione o banco 1 de memria pois o banco 4 no exite. h um erro.

				}
			}
		}

		//Escrita sequencial, lembrado que as pginas tem que ser de 128 em 128 Bytes (0 a 127). 
    	//at 3 x 65.536 = 196.608 Bytes  (0 a 196.607)
		//
		//--------------------------------
		//     0 ----- 127   - In. banco 1
		//   128 ----- 255
		//   256 ----- 383
		//   384 ----- 511
		//   639 ----- 766 
		//        ...
		// 65408 ----- 65535 - Fim banco 1
		//--------------------------------
		// 65536 ----- 65663 - In. banco 2
		//        ...
    	// 130944----- 131071- Fim banco 2
		//--------------------------------
		// 65536 ----- 65663 - In. banco 3
		//        ...
    	// 196352----- 196606- Fim banco 3
		//--------------------------------
		write_ext_eeprom_sequencial(endereco,a,tamanho_pacote,seleciona_men);

		//Uma pagina  composta de 128 Bytes (0-127), os pacotes viro em 43+43+42 = 128
		// 43 => ( 0  -  42) => prxima gravao iniciar em  43, assim o clculo ser  0+43
		// 43 => (43  -  85) => prxima gravao iniciar em  86, assim o clculo ser 86+43
		// 42 => (86  - 127) => prxima gravao iniciar em 128, assim o clculo ser 86+42
		//Finalizando a primeira pgina
		// 43 => (128 - 170) => prxima gravao iniciar em 171, assim o clculo ser 128+43
		// 43 => (171 - 213) => prxima gravao iniciar em 214, assim o clculo ser 171+43
		// 42 => (214 - 255) => prxima gravao iniciar em 256, assim o clculo ser 214+42
		//...

		sprintf(DatosBuffer,"mComand %02d%06ld%s;%04d ", tamanho_pacote,endereco,a, seleciona_men);

	}else{ //Se  maior que 196.607, manda o endereo de volta sem informao 
		sprintf(DatosBuffer,"mEstouro ;00000000000000000;00000;00000;00000;00000;00000;00000 ");
	}
}
//**************************************************************************** 


//----------------------------------------------------------------------
//zComando ;00000;00000;00000;00000;00000;00000;00000;00000;00000
//Definindo os endereos Vlidos para os bancos de memria
//memria 1
//0-65535 = 65536
//memria 2
//0-65535 = 65536
//memria 3
//0-65535 = 65536
//          ----- 
//Total   = 196608
//Endereo validos (0 - 196607)
//..................................................
//memria 1	End. Validos (0 + 65535) = 65535	  
//0			0   				
//65535		65535
//
//memria 2	End. Validos (65536 + 65535) = 131071	  
//0       	65536 	
//65535   	131071
//
//memria 3	End. Validos (131072  + 65535) = 196607	  
//0       	131072  
//65535   	196607
//------------------------------------------------------              
void apaga_memoria(void){
	
	int32 i;
	int8 a[128];

	for(i=0; i < 128 ;i++){
		if(i==127){
			a[i]=0xFF;
		}else{
			a[i]=0x00;
		}
	}
	
	//memria 1	End. Validos (0 + 65535) = (0 e 65535)	  
	//0			0   				
	//65535		65535
    for(i=0;i<=65535;i+=128){ 
		write_ext_eeprom_sequencial(i,a,128,1);
	}

	//memria 2	End. Validos (65536 + 65535) = (65536 e 131071)	  
	//0       	65536 	
	//65535   	131071
	for(i=65536;i<=131071;i+=128){
		write_ext_eeprom_sequencial(i,a,128,2);
	}

	//memria 3	End. Validos (131072  + 65535) = (131072 e 196607)	  
	//0       	131072  
	//65535   	196607
	for(i=131072;i<=196607;i+=128){
		write_ext_eeprom_sequencial(i,a,128,3);
	}	
	sprintf(DatosBuffer,"zComando ;00000;00000;00000;00000;00000;00000;00000;00000;00000 ");
}
//**************************************************************************** 

//**************************************************************************** 
void leitura_sequencial_memoria(){  //Somente para teste, no  util
	
	int   i;
	char  st1[7]="";//,st2[6]="";
	int32 endereco;
	int   tamanho_men; 
	int   seleciona_men;
	char  endereco_mem[18]="";
	int8  dado[128]; 

	//17- Byte para endereamento de memria--------------------------------------------
	for(i=10;i<=26;i++){
		endereco_mem[i-10]=DatosBuffer[i];
	}
	endereco_mem[17]='\0';
	//----------------------------------------------------------------------------------

	//----------------------------------------------------------------------------------
	for(i=28;i<=32;i++){
		st1[i-28]=DatosBuffer[i];
	}
	st1[6]='\0';
	//----------------------------------------------------------------------------------

	endereco=atof(endereco_mem);
	

	tamanho_men=atol(st1);

	//Estouro de memoria >196.607
	if( endereco <= 196607 ){			//Se o endereo for menor ou igual a 196607 entra, endereo vlido.
		seleciona_men = 1;				//Selecione o banco 1 de memria
		if(endereco>65535){				//Se for maior que entre (0 e 65535), ento pode ser banco 2 apartir de 65536;
			seleciona_men = 2;			//Selecione o banco 2 de memria
			if(endereco>131071){		//Se for maior que entre (65536 e 131071 ), ento pode ser banco 3 apartir de 131072;
				seleciona_men = 3;		//Selecione o banco 3 de memria
				if(endereco>196607){	//Se for maior que entre (131071 e 196607), ento pode ser banco 4 apartir de 196608;
					seleciona_men = 1;  //Selecione o banco 1 de memria pois o banco 4 no exite. h um erro.

				}
			}
		}
	
	//BYTE * read_ext_eeprom_sequencial(long int address, int tamanho_data, int dispositivo)
	
	//read_ext_eeprom_sequencial(long int address, BYTE data[], int tamanho_data, int dispositivo)
	//read_ext_eeprom_sequencial(endereco, dado,tamanho_men, seleciona_men);
/*
					  //"#Comando ;20000;00000;20000;00000;20000;00000;20000;20000;20000"
	sprintf(DatosBuffer,"%03d %03d %03d %03d %03d %03d %03d %03d %03d %03d %03d %03d %03d %03d %03d %03d ",
						dado[0],dado[1],dado[2],dado[3],dado[4],dado[5],dado[6],dado[7],
						dado[8],dado[9],dado[10],dado[11],dado[12],dado[13],dado[14],dado[15],);
*/
//	sprintf(DatosBuffer,"dComando ;%017Ld;%05d;%05d;%05d;%05d;%05d;%05d ",
//							endereco ,tamanho_men,seleciona_men,dado[0],dado[1],dado[2],dado[3]);
	sprintf(DatosBuffer,"%06ld;%06ld;%06ld;%06ld;%06ld;%06ld;%06ld;%06ld;%06ld;",
								endereco_memoria[0],endereco_memoria[1], endereco_memoria[2],
								endereco_memoria[3],endereco_memoria[4], endereco_memoria[5],
								endereco_memoria[6],endereco_memoria[7], endereco_memoria[8]);

	}else{
		//sprintf(DatosBuffer,"dEstouro ;00000000000000000;00000;00000;00000;00000;00000;00000 ");
	}
		//dComando ;00000000000000000;00000;00000;00000;00000;00000;00000					 
}
//**************************************************************************** 

//****************************************************************************
void tensao_ad_an0_an1(){

	float ad0,ad1;

    set_adc_channel(0);
	delay_us(80);
	ad0=read_adc();
							
    set_adc_channel(1);
	delay_us(80);
	ad1=read_adc();

	ad0=0.02466258*ad0;
	ad1=0.02466258*ad1;

	sprintf(DatosBuffer,"tComando ;AD0: %.3f,  AD1: %.3f,                                ",ad0,ad1);
	
	//printf(usb_cdc_putc,"AD0: %.3f, AD1: %.3f \r\n",ad0,ad1);
}
//**************************************************************************** 

//****************************************************************************
void recebe_pacote_usb(){
	  
	  //ejetar_USB();    //No ser habilitado para coneco direta USB

      if(usb_enumerated()){                              //enumerado a USB?
         if (usb_kbhit(1)){                              //Verifica dados USB

         	 usb_get_packet(1, DatosBuffer, TamBuffer); 
			//---------------------------------------------------------------------------------------------------------------------
        	if(1==dec_pac_comando()){          
				dec_pac_mem_servo_1_6();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	if(2==dec_pac_comando()){          
				dec_pac_mem_servo_7_15();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	if(3==dec_pac_comando()){           
				dec_pac_liga_desliga();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	if(4==dec_pac_comando()){          
				manda_dados_motor_pc1();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	if(5==dec_pac_comando()){          
				manda_dados_motor_pc2();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	if(6==dec_pac_comando()){           
				escrita_memoria();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	if(7==dec_pac_comando()){           
				leitura_memoria();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	if(8==dec_pac_comando()){           
				escrita_memoria_sequencial();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	//Gravacao do banco de memoria em bloco de 43+43+42 Bytes
			if(9==dec_pac_comando()){           
				escrita_memoria_bloco_128();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	//Gravacao do banco de memoria em bloco de 43+43+42 Bytes
			if(10==dec_pac_comando()){          
				apaga_memoria();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	//Leitura da memoria
			if(11==dec_pac_comando()){           
				leitura_sequencial_memoria();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			//---------------------------------------------------------------------------------------------------------------------
        	//Leitura da memoria
			if(12==dec_pac_comando()){           
				tensao_ad_an0_an1();
	  		}//if ComandoPC
			//---------------------------------------------------------------------------------------------------------------------

			usb_put_packet(1,DatosBuffer,64,USB_DTS_TOGGLE); //Devolve o pacote Recebido

	 }//if usb_kbhit
	}//if usb_enumerated
}
//****************************************************************************
